"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("./node-fetch");
const query_string_1 = require("query-string");
const defaultHeaders = {
    Accept: "application/json, text/plain, */*",
    "Content-Type": "application/json"
};
const formHeaders = {
    "Content-Type": "application/x-www-form-urlencoded;charset=UTF-8"
};
const supportsBlob = typeof window !== "undefined";
async function request(method, url, body, form = false, customHeaders = {}) {
    const init = {
        method,
        headers: {
            ...defaultHeaders,
            ...(form ? formHeaders : {}),
            ...customHeaders
        },
        body: body
            ? form
                ? query_string_1.stringify(body)
                : supportsBlob && body instanceof Blob
                    ? body
                    : JSON.stringify(body)
            : undefined
    };
    return fetch(url, init);
}
exports.default = request;
//# sourceMappingURL=request.js.map