"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function union(...collections) {
    return new Set(collections.reduce((a, v) => [...a, ...v], []));
}
exports.union = union;
function intersection(...collections) {
    return compareCollections((i, ...sets) => sets.every(s => s.has(i)), ...collections);
}
exports.intersection = intersection;
function difference(...collections) {
    return compareCollections((i, ...sets) => sets.every(s => !s.has(i)), ...collections);
}
exports.difference = difference;
function compareCollections(cb, ...collections) {
    const sets = collections.map(c => (c instanceof Set ? c : new Set(c)));
    const firstSet = sets.shift();
    if (firstSet === undefined)
        return new Set();
    return new Set([...firstSet].filter(i => cb(i, ...sets)));
}
//# sourceMappingURL=collections.js.map