/// <reference types="node" />
import { PathLike, Stats } from "fs";
export declare function unlink(path: PathLike): Promise<void>;
export declare function mkdir(path: PathLike): Promise<void>;
export declare function exists(path: PathLike): Promise<boolean>;
export declare function stat(path: PathLike): Promise<Stats>;
export declare function copy(src: PathLike, dst: PathLike, throwIfExists: boolean): Promise<void>;
export declare function symlink(src: string, linkPath: string, type?: "dir" | "file" | "junction"): Promise<void>;
export declare function createIfDoesntExist(folder: string): Promise<void>;
export declare function ls(path: PathLike, absolute?: boolean): Promise<string[]>;
/**
 * The path.extname() method returns the extension of the path, from the last occurrence of the . (period) character to end of string in the last portion of the path. If there is no . in the last portion of the path, or if the first character of the basename of path (see path.basename()) is ., then an empty string is returned.
 */
export declare function getFileExtension(path: PathLike): string;
export declare function getFileName(path: PathLike, withoutExtension?: boolean): string;
export declare function getFolderName(path: PathLike): string;
export declare function changeFileExtension(path: PathLike, newExtension: string): string;
declare type Encoding = "ascii" | "binary" | "base64" | "hex" | "ucs2" | "ucs-2" | "utf16le" | "utf-16le" | "utf8" | "utf-8" | "latin1";
export declare function read(path: PathLike, encoding?: Encoding): Promise<string>;
export declare function readBuffer(path: PathLike): Promise<Buffer>;
/**
 * @throws Error
 */
export declare function readJSON<T>(path: string): Promise<T>;
/** whitelist - what files to keep, defaults to /a^/ which matches nothing */
export declare const clearFolder: (folder: string, whitelist?: RegExp) => Promise<void[]>;
export declare function write(path: string, data: any, encoding?: string): Promise<void>;
export declare function isEOL(value: number): boolean;
export declare function yieldLinesFromFile(path: string): IterableIterator<string>;
export {};
