"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function all(re, str) {
    if (!re.global) {
        throw new Error("Executing regex.all on regex without global flag");
    }
    let exec = re.exec(str);
    const arr = [];
    while (exec !== null) {
        const [, ...captures] = exec;
        arr.push(captures);
        exec = re.exec(str);
    }
    return arr;
}
exports.all = all;
function single(re, str) {
    const exec = re.exec(str);
    if (!exec)
        return [];
    const [, ...captures] = exec;
    return captures;
}
exports.single = single;
function capture(re, str) {
    return re.global ? all(re, str) : single(re, str);
}
exports.default = capture;
//# sourceMappingURL=regex.js.map